import { ReactNode } from 'react';
import UniversalRouter, { Route, RouterOptions, Routes } from 'universal-router';
import { History, Path } from 'history';
export declare type RouterContext = {
    router: UniversalRouter;
    history: History;
    view: ReactNode;
    setView(view: ReactNode): void;
    loading?: number;
    setLoading(loading?: number): void;
    navigate: (to: string, state?: any) => void;
    cancel(): void;
};
declare type Location<T = any> = Path & {
    state: T;
};
declare type HistoryState = {
    locationStack: Location[];
    index?: number;
} | null;
declare type Props<R = any, C extends RouterContext = RouterContext> = {
    children: ReactNode;
    routes: Routes<R, C> | Route<R, C>;
} & RouterOptions<R, C>;
export declare function BaseRouter<R = any, C extends RouterContext = RouterContext>({ routes, history, children, ...rest }: Props<R, C> & {
    history: History<HistoryState>;
}): JSX.Element;
export declare function Router<R = any, C extends RouterContext = RouterContext>(props: Props<R, C>): JSX.Element;
export declare function useRouter(): RouterContext;
export declare function useLoading(): number | undefined;
export declare function View(): JSX.Element;
export {};
